Package org.optaplanner.core.impl.domain.variable.inverserelation

## Class CollectionInverseVariableListener<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.domain.variable.inverserelation.CollectionInverseVariableListener<Solution_>

- All Implemented Interfaces:
    `Closeable`, `AutoCloseable`, `VariableListener<Solution_,​Object>`, `CollectionInverseVariableSupply`, `Supply`

      public class CollectionInverseVariableListener<Solution_>
      extends Object
      implements VariableListener<Solution_,​Object>, CollectionInverseVariableSupply

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected InverseRelationShadowVariableDescriptor<Solution_>` | `shadowVariableDescriptor` |
    `protected VariableDescriptor<Solution_>` | `sourceVariableDescriptor` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `CollectionInverseVariableListener​(InverseRelationShadowVariableDescriptor<Solution_> shadowVariableDescriptor, VariableDescriptor<Solution_> sourceVariableDescriptor)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `afterEntityAdded​(ScoreDirector<Solution_> scoreDirector, Object entity)` |
    `void` | `afterEntityRemoved​(ScoreDirector<Solution_> scoreDirector, Object entity)` |
    `void` | `afterVariableChanged​(ScoreDirector<Solution_> scoreDirector, Object entity)` |
    `void` | `beforeEntityAdded​(ScoreDirector<Solution_> scoreDirector, Object entity)` |
    `void` | `beforeEntityRemoved​(ScoreDirector<Solution_> scoreDirector, Object entity)` |
    `void` | `beforeVariableChanged​(ScoreDirector<Solution_> scoreDirector, Object entity)` |
    `Collection<?>` | `getInverseCollection​(Object planningValue)` | If entity1.varA = x then an inverse of x is entity1.
    `protected void` | `insert​(InnerScoreDirector<Solution_,​?> scoreDirector, Object entity)` |
    `protected void` | `retract​(InnerScoreDirector<Solution_,​?> scoreDirector, Object entity)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.api.domain.variable.VariableListener

      `close, requiresUniqueEntityEvents, resetWorkingSolution`

- - ### Field Detail

    - #### shadowVariableDescriptor

          protected final InverseRelationShadowVariableDescriptor<Solution_> shadowVariableDescriptor

    - #### sourceVariableDescriptor

          protected final VariableDescriptor<Solution_> sourceVariableDescriptor

  - ### Constructor Detail

    - #### CollectionInverseVariableListener

          public CollectionInverseVariableListener​(InverseRelationShadowVariableDescriptor<Solution_> shadowVariableDescriptor,
                                                   VariableDescriptor<Solution_> sourceVariableDescriptor)

  - ### Method Detail

    - #### beforeEntityAdded

          public void beforeEntityAdded​(ScoreDirector<Solution_> scoreDirector,
                                        Object entity)

      Specified by:
        `beforeEntityAdded` in interface `VariableListener<Solution_,​Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### afterEntityAdded

          public void afterEntityAdded​(ScoreDirector<Solution_> scoreDirector,
                                       Object entity)

      Specified by:
        `afterEntityAdded` in interface `VariableListener<Solution_,​Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### beforeVariableChanged

          public void beforeVariableChanged​(ScoreDirector<Solution_> scoreDirector,
                                            Object entity)

      Specified by:
        `beforeVariableChanged` in interface `VariableListener<Solution_,​Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### afterVariableChanged

          public void afterVariableChanged​(ScoreDirector<Solution_> scoreDirector,
                                           Object entity)

      Specified by:
        `afterVariableChanged` in interface `VariableListener<Solution_,​Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### beforeEntityRemoved

          public void beforeEntityRemoved​(ScoreDirector<Solution_> scoreDirector,
                                          Object entity)

      Specified by:
        `beforeEntityRemoved` in interface `VariableListener<Solution_,​Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### afterEntityRemoved

          public void afterEntityRemoved​(ScoreDirector<Solution_> scoreDirector,
                                         Object entity)

      Specified by:
        `afterEntityRemoved` in interface `VariableListener<Solution_,​Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### insert

          protected void insert​(InnerScoreDirector<Solution_,​?> scoreDirector,
                                Object entity)

    - #### retract

          protected void retract​(InnerScoreDirector<Solution_,​?> scoreDirector,
                                 Object entity)

    - #### getInverseCollection

          public Collection<?> getInverseCollection​(Object planningValue)

      Description copied from interface: `CollectionInverseVariableSupply`
      If entity1.varA = x then an inverse of x is entity1.
      Specified by:
        `getInverseCollection` in interface `CollectionInverseVariableSupply`
      Parameters:
        `planningValue` - never null
      Returns:
        never null, a `Collection` of entities for which the planning variable is the planningValue.